/*  FCat.CMD

   Dieses Tool zeigt den Verzeichniskatalog mit
   Beschreibungen an.

Detlev Ahlgrimm  20.06.1995
*/
PARSE ARG args

SIGNAL ON FAILURE NAME CLEANUP
SIGNAL ON HALT    NAME CLEANUP
SIGNAL ON SYNTAX  NAME CLEANUP

IF RxFuncQuery('SysLoadFuncs')=1 THEN DO
   CALL RxFuncAdd 'SysLoadFuncs', 'REXXUTIL', 'SysLoadFuncs'
   CALL SysLoadFuncs
END

PARSE VALUE SysTextScreenSize() WITH zeilen spalten

IF args="" THEN args="*"

rc=SysFileTree(args, "files", "BT", "**-*-")
/*CALL SortIt*/

DO i=1 TO files.0
   PARSE VALUE files.i WITH j "/" m "/" t "/" h "/" mi fsize ftype fname
   fname=STRIP(fname)

   tname=FILESPEC("name", fname)
   IF LENGTH(tname)>12 THEN tname=LEFT(FILESPEC("name", fname), 11)""
   ELSE                     tname=LEFT(FILESPEC("name", fname), 12)
   CALL CHAROUT , tname

   IF POS("D", ftype)>0 THEN CALL CHAROUT , "    <DIR>"
   ELSE                      CALL CHAROUT , RIGHT(fsize, 9)

   CALL CHAROUT , "  "t"."m"."j"  "h":"mi" "

   rc=SysGetEA(fname, "PROG_DESCRIPTION", "des")
   IF rc<>0 THEN des=""
   CALL PrintDes
END

CLEANUP:
EXIT 0



/* ----------------------------------------------
   Beschreibung hbsch formatiert ausgeben
*/
PrintDes:
   lng=spalten-40
   name=""
   IF LENGTH(des)>lng THEN DO
      des=SPACE(des)
      DO WHILE LENGTH(des)>0
         IF LENGTH(des)>lng THEN DO
            p=LASTPOS(" ", des, lng)
            IF p=0 THEN p=lng
         END; ELSE
            p=LENGTH(des)
         SAY name || LEFT(des, p)
         des=SUBSTR(des, p+1)
         name=COPIES(" ", 39)
      END
   END; ELSE
      SAY des
RETURN



/* ----------------------------------------------
   Selection Sort
*/
SortIt:
   DO k=1 TO files.0-1
      min=k
      DO j=k+1 TO files.0
         IF WORD(files.j, 4)<WORD(files.min, 4) THEN
            min=j
      END
      swp=files.min
      files.min=files.k
      files.k=swp
   END
RETURN
