/*  XCat.CMD

   Dieses Tool zeigt den Verzeichniskatalog mit
   Beschreibungen an. Parameter wie DIR
   allerdings nur im aktuellen Verzeichnis und
   nur mit den Parameter /O, /A oder /L

Detlev Ahlgrimm    21.06.1995
*/
PARSE ARG args

SIGNAL ON FAILURE NAME CLEANUP
SIGNAL ON HALT    NAME CLEANUP
SIGNAL ON SYNTAX  NAME CLEANUP

IF RxFuncQuery('SysLoadFuncs')=1 THEN DO
   CALL RxFuncAdd 'SysLoadFuncs', 'REXXUTIL', 'SysLoadFuncs'
   CALL SysLoadFuncs
END

PARSE VALUE SysTextScreenSize() WITH zeilen spalten

/* eigene Queue anlegen */
MyQueue =RXQueue("Create")
OldQueue=RXQueue("Set", MyQueue)


"@DIR /N "args" | RxQueue" MyQueue
i=0
DO WHILE Queued()>0
   i=i+1
   PARSE PULL ln.i
END
ln.0=i

SAY ln.1
SAY ln.2
SAY ln.3
SAY ln.4

DO i=5 TO ln.0-2
   fname=SUBWORD(ln.i, 5)
   rc=SysGetEA(fname, "PROG_DESCRIPTION", "des")
   IF rc<>0 THEN des=""
   CALL PrintLine
END

idx=ln.0-1
SAY ln.idx
idx=idx+1
SAY ln.idx


CLEANUP:
rc=RXQueue("Delete", MyQueue)
rc=RXQueue("Set", OldQueue)
EXIT


/* ----------------------------------------------
   Namen und Attribute formatieren
*/
PrintLine:
   IF LENGTH(fname)>12 THEN fname=LEFT(fname, 11)""
   ELSE                     fname=LEFT(fname, 12)
   CALL CHAROUT , fname" "
   CALL CHAROUT , RIGHT(SPACE(TRANSLATE(WORD(ln.i, 3), " ", "."), 0), 8)
   CALL CHAROUT , RIGHT(WORD(ln.i, 1), 10)
   CALL CHAROUT , RIGHT(WORD(ln.i, 2), 7)" "
   CALL PrintDes
RETURN


/* ----------------------------------------------
   Beschreibung hbsch formatiert ausgeben
*/
PrintDes:
   lng=spalten-40
   name=""
   IF LENGTH(des)>lng THEN DO
      des=SPACE(des)
      DO WHILE LENGTH(des)>0
         IF LENGTH(des)>lng THEN DO
            p=LASTPOS(" ", des, lng)
            IF p=0 THEN p=lng
         END; ELSE
            p=LENGTH(des)
         SAY name || LEFT(des, p)
         des=SUBSTR(des, p+1)
         name=COPIES(" ", 39)
      END
   END; ELSE
      SAY des
RETURN

